use serde::Serialize;

#[derive(Serialize)]
pub struct Response<T> {
    pub ok: bool,
    pub failure: Option<String>,
    pub result: Option<T>
}

pub fn failure<T>(failure: T) -> Response<T> where T: ToString {
    Response {
        ok: false,
        result: None,
        failure: Some(failure.to_string()),
    }
}

pub fn success<T>(result: T) -> Response<T> {
    Response {
        ok: true,
        failure: None,
        result: Some(result)
    }
}