use actix_web::{Responder, HttpResponse, web::{ServiceConfig, Data, scope}, get};
use serde::Serialize;
use crate::State;

mod posts;
mod auth;

#[derive(Serialize)]
struct PingResponse {
    version: String
}

#[get("/")]
async fn index(state: Data<State>) -> impl Responder {
    let response = PingResponse {
        version: state.config.api_version.clone(),
    };

    HttpResponse::Ok().json(response)
}

pub fn init_routes(cfg: &mut ServiceConfig) {
    cfg
        .service(index)
        .service(scope("/api/v1")
            .configure(posts::init_routes)
            .configure(auth::init_routes)
        );
}